#import "mymacros.h"

#define ef existing_file

int macos_version ();

void post_system_event (NSString* object, NSString* evt, NSDictionary* info);
void unbind_system_event (NSString* src, NSString* evt, id dst);
void bind_system_event (NSString* src, NSString* evt, id dst, SEL sel);

NSArray* ls_files (NSString *p);
NSString* existing_file (NSArray* fl);
NSString* file_md5 (NSString* path);
BOOL file_exists (NSString *path);
BOOL dir_exists (NSString *path);
BOOL path_exists (NSString *path);
BOOL is_filetype (NSString *path, NSString* type);
BOOL is_bundle (NSString* path);
BOOL mk_dir (NSString *path);
BOOL mk_dirs (NSString *path);
BOOL rm_files (NSString *path);
BOOL rm_file (NSString *path);
BOOL trash_files (NSString* src);
BOOL ln_file (NSString *from, NSString* to);
BOOL chmod_files (NSString *file, NSUInteger mode);
unsigned long long file_size (NSString* fl);
NSDate* file_mdate (NSString* fl);
BOOL has_changed (NSString* fl, NSDate* dt);
NSString* mk_temp ();
NSString* mk_temp_fileext (NSString* ext);
NSString* mk_temp_filename (NSString* nm);
NSString* mk_unique_filename (NSString* path);
BOOL mv_files (NSString *src, NSString*dst);
BOOL mv_file (NSString *src, NSString*dst);
BOOL cp_files (NSString *src, NSString*dst);
BOOL cp_file (NSString *src, NSString*dst);
BOOL touch_files (NSString *src);

void bind_path (id src, NSString* spath, id dest, NSString* dpath);
void eval_path (id src, NSString* binding, id value);

NSString* pipe_shell (NSString* datastr, NSString* cmd);
NSString* eval_shell (NSString* cmd);
void open_file (NSString* file);
void open_url (id url);

NSString* ensure_dirname_exists (NSString* path);
NSString* ensure_dir_exists (NSString* path);

void file_ext_show (NSString* path);
void file_ext_hide (NSString* path);

void save_image (NSImage* img, NSString* path);
NSBitmapImageRep* resize_image_rep (NSBitmapImageRep* sourceImage, NSSize size);
NSImage* resize_image (NSImage* sourceImage, NSSize size);

NSImage* file_icon (NSString* path);
NSImage* file_thumbnail (NSString* path);
NSString* file_mdata (NSString *path, const NSString* name);

NSString* f(id it, ...);

NSString* displayname (NSString* path);

NSColor* rgba (CGFloat r, CGFloat g, CGFloat b, CGFloat a);

void eval_shell_bg (NSString* cmd);
NSString* eval_shell (NSString* cmd);

NSRect MYGrowRect (NSRect r, float dx, float dy);

NSBitmapImageRep* take_window_screenshot (CGWindowID windowID);
CGWindowID frontmost_window_id ();